<?php
/* ===================================================
   Template Klasse
   Copyright: Nils Reimers 2005 ( www.php-einfach.de )
	Version: 0.1
	Geschrieben f&uuml;r: Command Board 1.0 Beta 2.0
   =================================================== */

class template
	{
	//Einstellungen f&uuml;r das Template
	var $tplName; 							 //Name des Templates
	var $tplFolder;    					 //Ordner des Templates
	var $tplEndung = "tpl";           //Endung der Templates
	var $tplLoad;                     //Geladenes Template
	var $tplID;                       //ID des Designs
	var $tplPfad;                     //Pfad zur Templatedatei

	//Einstellungen f&uuml;r den Cache
	var $cacheFolder = "cache";       //Ordner des Cache
	var $cacheEndung = "php";         //Endung des Cache
	var $cachePfad;                   //Pfad zur Cachedatei

	//Einstellung zur Verarbeitung von Templates
	var $globalVars = 1;              //Globale Variablen benutzen
	var $globalVarsPhpCode = 1;       //$Variablen per <*?php $var; ?*> einschlie&szlig;en
   var $globalVarsEcho = 1;          //$Variablen per echo ausgeben
	var $chmodWrite = "0777";          //CHMOD Rechte zum schreiben
	var $chmodRead = "0644";
	var $tagzeichen_start = "[\{<]";  //Begrenzungtags
   var $tagzeichen_ende = "[\}>]";   //Begrenzungtags
   var $leerzeichen = "[ ]*";

   //Einsprung um Template zu laden
	//&Uuml;berpr&uuml;fen ob es seit dem ge&auml;ndert wurde
	function load($tplName,$tplFolder,$tplID=0,$ersetzungen=1)
		{
		$this->tplFolder = $tplFolder;
      $this->tplName = $tplName;
      $this->tplID = $tplID;

      $this->tplPfad = $this->tplFolder."/".$this->tplName.".".$this->tplEndung;
      $this->cachePfad = $this->cacheFolder."/".$this->tplID."_".$this->tplName.".".$this->cacheEndung;

		if(!file_exists($this->cachePfad))
			{
         $this->getTemplate($this->tplName,$this->tplFolder,$ersetzungen);
			}
		else
			{
         $templateTime = filemtime($this->tplPfad);
			$cacheTime = filemtime($this->cachePfad);
         #$cacheTime = 123; //Aktivieren wenn Dateien nicht aus dem Cache geladen werden soll

			//Template hat sich ge&auml;ndert => Ersetzen und dann im Cache speichern
			if($templateTime > $cacheTime)
				{
				$this->getTemplate($this->tplName,$this->tplFolder,$ersetzungen);
				}
			//Cache Datei ist auf dem neustem Stand => Datei ausgeben
			else
				{
				$this->ausgabe($this->cachePfad);
				}
			}

		return 0;
		} //function: load($name)

	//Rohes Template laden
	function getTemplate($tplName,$tplFolder,$ersetzungen=1)
		{
      $tplLoad = @implode("",file($this->tplFolder."/".$tplName.".".$this->tplEndung));
      $this->tplLoad = $tplLoad;


		if($ersetzungen == 1 AND $tplLoad == true)
			{
			//Ersetzungen durchf&uuml;hren
			$this->ersetzungen();
			}
      //Speichern im Cache
		if($tplLoad == true)  $this->caching();

		return 0;
		}

   //Template in Cache speichern
	function caching()
		{
      $dateiname = $this->cachePfad;

		//Gibt es die Datei bereits
		if(!file_exists($dateiname))
			{
         $userdatei = @fopen($dateiname,"w");
	      $schreiben = @fwrite($userdatei, $this->tplLoad);
	      @fclose($userdatei);

         $error_msg = "
			Fehler-ID: 1<br>
			Fehler beim erstellen der Cache Datei: <b>$dateiname</b><br>
			Template Datei: <b>$this->tplName</b><br>
			Der Ordner <b>$this->cacheFolder</b> ben&ouml;tigt die Schreibrechte CHMOD 777<br><br>";
			}
		else
			{
      	//Schreibrechte geben
	      if(!is_writeable($dateiname))
	         {
				$chmod = @chmod($dateiname,0777);
				}

	      //Schreibrechte m&ouml;g.
	      if(is_writeable($dateiname))
	         {
            $userdatei = @fopen($dateiname,"w");
	      	$schreiben = @fwrite($userdatei, $this->tplLoad);
	      	@fclose($userdatei);

            $error_msg = "
				Fehler-ID: 2<br>
				Fehler beim speichern der Cache-Datei: <b>$dateiname</b> <br>
				Template Datei: <b>$this->tplName</b><br><br>";
	         }
	      else
	         {
	         $unlink = @unlink($dateiname);
	         $userdatei = @fopen($dateiname,"w");
	         $schreiben = @fwrite($userdatei, $this->tplLoad);
	         @fclose($userdatei);

            $error_msg = "
				Fehler-ID: 3<br>
				Fehler beim l&ouml;schen der Cache-Datei: <b>$dateiname</b> <br>
				Template Datei: <b>$this->tplName</b><br><br>

				Cache-Dateien bitte <b>nicht</b> mit hochladen, evt. diese per Hand l&ouml;schen<br><br>";
	         }
			} //else: !file_exists($dateiname)

		if($schreiben == false)
			{
         echo "<br><br><font color=\"red\"><b>Fehler:</b></font><br>";
			echo $error_msg;
         echo "
         <b><a target=\"_blank\" href=\"http://www.php-einfach.de/download_template_faq.php\">Hilfe</a></b><br><br>
			";
			}

      $this->ausgabe($dateiname);

		return 0;
		}

	//Template ausgeben
   function ausgabe($pfad)
		{
		global $design_row;
		@include("$pfad");
		return 0;
		}

   /* ============================
	     Ersetzungen im Template
		============================ */

	//Funktion die andere Ersetzungen aufruft
	function ersetzungen()
		{
		$this->geschuetzttags();
		$this->kommentartags();
      $this->designtags();

      if($this->globalVars == 1)
			{
			$this->globalVars();
			}

      $this->funktiontags();
      $this->iftags();
		$this->switchtags();
	   $this->includetags();
		$this->entschuetzentags();

		return 0;
		} //function ersetzungen()

	//{ge}Gesch&uuml;tze{/ge} Zeilen "sch&uuml;tzen"
	function geschuetzttags()
		{
      $s = $this->tagzeichen_start;
		$e = $this->tagzeichen_ende;

      $this->tplLoad = preg_replace_callback("/{$s}ge{$e}(.*){$s}\/ge{$e}/si", array(&$this,'schuetzen'), $this->tplLoad);
		} //function geschuetzttags()

	//Gesch&uuml;tze Zeilen dekodieren
   function entschuetzentags()
		{
      $this->tplLoad = preg_replace_callback("/\{ge\}(.*?)\{\/ge\}/si", array(&$this,'entschuetzen'), $this->tplLoad);
		} //function geschuetzttags()


	//Kommentare ersetzen
	function kommentartags()
		{
      while(eregi("{\*(.*)\*}",$this->tplLoad)) $this->tplLoad = preg_replace_callback("/\{\*(.*?)\*\}/s", array(&$this,'kommentareErsetzen'), $this->tplLoad);
		return 0;
		} //function kommentartags()



	//Design Tags ersetzen
	function designtags()
		{
		//Design Array laden
      global $design_row;

	   foreach($design_row AS $feld  => $werte)
	      {
	      $this->tplLoad = eregi_replace("\{$feld\}",$werte,$this->tplLoad);
	      }

		return 0;
		} //function design()

	//Variablen in globale Variablen wandeln
	function globalVars()
		{
      $s = $this->tagzeichen_start;
		$e = $this->tagzeichen_ende;
		$zeichen_vars = "[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*";

		$objekte = "($zeichen_vars)(\-\>)($zeichen_vars)";
		$array = "($zeichen_vars)\[(.*?)\]";
		$normale = "($zeichen_vars)";



      //{$variable} die ausgegeben werden soll
      $this->globalVarsPhpCode = 1;
		$this->globalVarsEcho = 1;
      $this->tplLoad = preg_replace_callback("/{$s}\\$($objekte|$array|$normale){$e}/si", array(&$this,'variable'), $this->tplLoad);

		//Normale $variable
      $this->globalVarsPhpCode = 0;
		$this->globalVarsEcho = 0;
		$this->tplLoad = preg_replace_callback("/\\$($objekte|$array|$normale)/si", array(&$this,'variable'), $this->tplLoad);

		return 0;
		} //function globalVars();


	//Funktionen aufrufen
	function funktiontags()
		{
      $s = $this->tagzeichen_start;
		$e = $this->tagzeichen_ende;
		$l = $this->leerzeichen;

		$zeichen_vars = "[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*";

		$this->tplLoad = preg_replace("/{$s}funktion{$e}(.*?){$s}\/funktion{$e}/si", "<?php \\1; ?>", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}funktion{$l}(ausgabe|echo|print|output){$e}(.*?){$s}\/funktion{$e}/si", "<?php echo \\2; ?>", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}funktion{$l}\\$(.*?){$e}(.*?){$s}\/funktion{$e}/si", "<?php \\$\\1 = \\2; ?>", $this->tplLoad);
      $this->tplLoad = preg_replace_callback("/{$s}funktion{$l}\{ge\}(.*?)\{\/ge\}{$e}(.*?){$s}\/funktion{$e}/si", array(&$this,'entschuetzenFunktion'), $this->tplLoad);

		return 0;
		} //function funktiontags()

	//IF-Anweisungen ersetzen
	function iftags()
		{
      $s = $this->tagzeichen_start;
		$e = $this->tagzeichen_ende;

      $this->tplLoad = preg_replace("/{$s}if{$e}(.*?){$s}\/if{$e}/si", "<?php if(\\1): ?>", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}else( |)if{$e}(.*?){$s}\/elseif{$e}/si", "<?php elseif(\\2): ?>", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}else{$e}/si", "<?php else: ?>", $this->tplLoad);
		$this->tplLoad = preg_replace("/{$s}\/else{$e}/si", "", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}(\/|)endif{$e}/si", "<?php endif; ?>", $this->tplLoad);
		return 0;
		}

   //Switch-Anweisungen ersetzen
	function switchtags()
		{
      $s = $this->tagzeichen_start;
		$e = $this->tagzeichen_ende;

      $this->tplLoad = preg_replace("/{$s}switch{$e}(.*?){$s}\/switch{$e}/si", "<?php switch(\\1): ?>", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}case\((.*?)\){$e}(.*?){$s}\/case{$e}/si", "<?php case \\1: ?> \\2 <?php break; ?>", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}default{$e}/si", "<?php default: ?>", $this->tplLoad);
		$this->tplLoad = preg_replace("/{$s}\/default{$e}/si", "", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}(\/|)endswitch{$e}/si", "<?php endswitch; ?>", $this->tplLoad);
		return 0;
		}


	//Includes
	function includetags()
		{
      $s = $this->tagzeichen_start;
		$e = $this->tagzeichen_ende;
		$l = $this->leerzeichen;

		$wert = "([^\"<\{ ]*)";

      $include_template = "<?php
\$ausgabe = new template;
\$ausgabe->load(\"\\1\",\$design_row['templatefolder'],\$design_row['templateid']);
?>";
      $include_template_genau = "<?php
\$ausgabe = new template;
\$ausgabe->load(\"\\1\",\"\\2\",\\3);
?>";


      $this->tplLoad = preg_replace("/{$s}(include|include_once|require|require_once){$l}file=(\"|)(.*?)(\"|){$e}/si", "<?php \\1(\"\\3\"); ?>", $this->tplLoad);

		$this->tplLoad = preg_replace("/{$s}include{$l}template=$wert{$e}/si", "$include_template", $this->tplLoad);
      $this->tplLoad = preg_replace("/{$s}include{$l}template=\"([^\"]*)\"{$e}/si", "$include_template", $this->tplLoad);

		$this->tplLoad = preg_replace("/{$s}include{$l}template=$wert templatefolder=$wert{$l}templateid=$wert{$e}/si", "$include_template_genau", $this->tplLoad);
		$this->tplLoad = preg_replace("/{$s}include{$l}template=\"([^\"]*)\"{$l}templatefolder=\"([^\"]*)\"{$l}templateid=\"([^\"]*)\"{$e}/si", "$include_template_genau", $this->tplLoad);

		return 0;
		}



	/* =======================
	    Funktionen die von
		 Ersetzungsfunktionen
		 aufgerufen werden
		====================== */

	//Kommentare ersetzen
   function kommentareErsetzen($text)
		{
		$aus = "";
		if(eregi("{\*",$text[1]))
			{
			$anzahl = explode("{*",$text[1]);
			for($i=1;$i<count($anzahl);$i++)
				{
            $aus .= " {*";
				}
			}
		return $aus;
		}

	//Variable in globale wandeln und in PHP Tag einbinden
   function variable($variable)
   	{
		$phpstart=$this->globalVarsPhpCode;
		$echo=$this->globalVarsEcho;

		$zeichen_vars = "[^a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*";

		$name = $variable[1];
	   $globals_name = $variable[5];
	   $result = "";

		if($phpstart==1) $result = "<?php ";
		if($echo==1) $result .= "echo ";



	   if($globals_name != "GLOBALS")
	      {
         //Normale Variable
			if(!preg_match("/($zeichen_vars)/si",$name))
				{
	      	$result .= "\$GLOBALS['".$name."']";
				}

			//Ist es ein Array?
			elseif(preg_match("/\[(.*?)\]/si",$name))
				{
	      	$result .= "\$GLOBALS['".$variable[5]."'][".$variable[6]."]";
				}

			//Ist es ein Objekt?
			elseif(preg_match("/\-\>/si",$name))
				{
	      	$result .= "\$GLOBALS['".$variable[2]."']->".$variable[4];
				}
	      }
	   else
	      {
	      $result .= "\$$name";
	      }

      if($echo==1) $result .= ";";
	   if($phpstart==1) $result .= " ?>";

	   return $result;
	   } //function variable

   //Gesch&uuml;tze Zeilen kodieren
	function schuetzen($text)
		{
		$text = "{ge}".$text[1]."{/ge}";

		//M&ouml;gliche Schreibweisen anpassen
		//Gro&szlig; und Kleinschreibung anpassen
		$text = eregi_replace("{ge}","{ge}",$text);
      $text = eregi_replace("{/ge}","{/ge}",$text);
      $text = eregi_replace("<ge>","{ge}",$text);
      $text = eregi_replace("</ge>","{/ge}",$text);

      $code = $text;


		$a = 0;
		$open = 0;
      $start_old = 0;

		//Schleife mit max. 255 durchl&auml;ufen, schutz vor Fehlern
		while($a < 255)
			{
			$a++;
         $start = strpos($code,"{ge}");
			$ende = strpos($code,"{/ge}");

          if($ende == false)
				{
				$ausgabe .= "{ge}".base64_encode(substr($text,4,-5))."{/ge}";
				break;
				}

			//{ge} wird ge&ouml;ffnet
			if($start < $ende)
				{
				$open++;
				$code = substr($code, $start+4);
				$ende_old += $start+4;
				}
			//{/ge} erscheint zuerst
         else
				{
				$open--;
				$code = substr($code, $ende+5);

				$ende_old += $ende+5;
				}
         //Alle offnen Tags wurden wieder geschlossen => Text kodieren
         if($open == 0)
				{
				$start_next = strpos($code,"{ge}");
				$ausgabe .= "{ge}".base64_encode(substr($text, $start_old+4,$ende_old-9))."{/ge}";
				$ausgabe .= substr($text, ($start_old+$ende_old),$start_next);
				$code = substr($text, ($start_old+$ende_old+$start_next));

            $text = $code;
				$start_old = 0;
            $ende_old = 0;
				}
			}

      return $ausgabe;
		}

   //Gesch&uuml;tze Zeilen kodieren
	function entschuetzen($text)
		{
      $text = base64_decode($text[1]);
      return $text;
		}

	//Funktionen mit R&uuml;ckgabe an eine gesch&uuml;tzte Variable
	function entschuetzenFunktion($text)
		{
      $text = "<?php ".base64_decode($text[1])." = ".$text[2]."; ?>";
		return $text;
		}

	} //class Template


?>